module AdvancedDCL
  module Solid
    def param_init
      @param = Parameter.new(Common.param)
      @param.init("lineindex", Fixnum, "scspli", "scqpli", 1, 1)
      @param.init("npmskip", Fixnum, "sgrset", "sgsget", 0, 0)
      @param.init("marktype", Fixnum, "scspmt", "scqpmt", 1, 1)
      @param.init("markindex", Fixnum, "scspmi", "scqpmi", 1, 1)
      @param.init("marksize", Float, "scspms", "scqpms", 1, 1)
      @param.init("tpat", [Fixnum, 2], "scstnp", "scqtnp", 2, 2)

      @temp_param = @param.dup
      @backup = @param.dup
    end
    
    private :param_init	

#------------------- method for parameters----------------------

    def set(key, val)
      @param[key] = val
    end

    def get(key)
      @param[key]
    end

#------------ draw method ----------------------

    def plot(x, y, z, temp=nil)
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.set3dtrf

      DCL.scplu(x.length, x, y, z)

      @backup.sync
      @temp_param.clear
    end

    def vplot(x, y, z, temp=nil)
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.set3dtrf

      DCL.scplv(x.length, x, y, z)

      @backup.sync
      @temp_param.clear
    end

    def mark(x, y, z, temp=nil)
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.set3dtrf

      DCL.scpmu(x.length, x, y, z)

      @backup.sync
      @temp_param.clear
    end

    def vmark(x, y, z, temp=nil)
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.set3dtrf

      DCL.scpmv(x.length, x, y, z)

      @backup.sync
      @temp_param.clear
    end

    def tone(x, y, z, temp=nil)
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.set3dtrf

      DCL.sctnu(x, y, z)

      @backup.sync
      @temp_param.clear
    end

    def vtone(x, y, z, temp=nil)
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.set3dtrf

      DCL.sctnv(x, y, z)

      @backup.sync
      @temp_param.clear
    end

    module_function :param_init
    module_function :set
    module_function :get
    module_function :plot
    module_function :vplot
    module_function :mark
    module_function :vmark
    module_function :tone
    module_function :vtone

    param_init
    
#----------------------------------------------------------
    
    @param.keys.each{|i|
      eval "def #{i}; @param['#{i}']; end"
      eval "def #{i}=(val); set('#{i}', val); end"
    }
  
    @param.keys.each{|i|
      eval "module_function :#{i}"
      eval "module_function :#{i}="
    }
  end
end
